"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = applyPrism;

var _loadModule = _interopRequireDefault(require("./loadModule"));

var _getLanguages = _interopRequireDefault(require("./getLanguages"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var importPrism = function importPrism() {
  return import(
  /* webpackChunkName: 'codeblock/prismjs' */
  'prismjs');
};
/**
 * Async function that loads and applies prism. See `hooks/usePrism`.
 */


function applyPrism(_x, _x2) {
  return _applyPrism.apply(this, arguments);
}

function _applyPrism() {
  _applyPrism = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(element, options) {
    var language, theme, isContainer, async, callback, isMounted, Prism, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, lang;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            //
            language = options.language, theme = options.theme, isContainer = options.isContainer, async = options.async, callback = options.callback;

            isMounted = function isMounted() {
              return !!element;
            };

            _context.next = 4;
            return importPrism();

          case 4:
            Prism = _context.sent;

            if (!(isMounted() && theme)) {
              _context.next = 8;
              break;
            }

            _context.next = 8;
            return (0, _loadModule.default)('theme', theme);

          case 8:
            if (!(isMounted() && language)) {
              _context.next = 11;
              break;
            }

            _context.next = 11;
            return (0, _loadModule.default)('language', language);

          case 11:
            if (!(isMounted() && isContainer)) {
              _context.next = 39;
              break;
            }

            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context.prev = 15;
            _iterator = (0, _getLanguages.default)(element)[Symbol.iterator]();

          case 17:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context.next = 25;
              break;
            }

            lang = _step.value;

            if (!(isMounted() && lang)) {
              _context.next = 22;
              break;
            }

            _context.next = 22;
            return (0, _loadModule.default)('language', lang);

          case 22:
            _iteratorNormalCompletion = true;
            _context.next = 17;
            break;

          case 25:
            _context.next = 31;
            break;

          case 27:
            _context.prev = 27;
            _context.t0 = _context["catch"](15);
            _didIteratorError = true;
            _iteratorError = _context.t0;

          case 31:
            _context.prev = 31;
            _context.prev = 32;

            if (!_iteratorNormalCompletion && _iterator.return != null) {
              _iterator.return();
            }

          case 34:
            _context.prev = 34;

            if (!_didIteratorError) {
              _context.next = 37;
              break;
            }

            throw _iteratorError;

          case 37:
            return _context.finish(34);

          case 38:
            return _context.finish(31);

          case 39:
            if (isMounted()) {
              isContainer ? Prism.highlightAllUnder(element, async, callback) : Prism.highlightElement(element, async, callback);
            }

          case 40:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[15, 27, 31, 39], [32,, 34, 38]]);
  }));
  return _applyPrism.apply(this, arguments);
}
//# sourceMappingURL=applyPrism.js.map