import React from 'react';

export default function useExternalContent(url, loadExternal) {
    const [content, setContent] = React.useState('');
    React.useEffect(
        () =>
            loadExternal(url, (error, result) => {
                if (error) {
                    console.warn(`Failed loading "${url}"`);
                } else {
                    setContent(result);
                }
            }),
        [url]
    );
    return content;
}
